//1000,"przel_zb.sci","przel_zb.sci",2.64,SYSTEM
//Copyright (c) Sage sp. z o.o.. Wszelkie prawa zastrzeone.

#include "defdok.sci"
#include "form.sci"
#include "kth.sci"
#include "rozlist.sci"

#define GR getRec
#define GF getField
#define SF setField
#define SK setKey
#define SKS setKeySeg
#define GAT getAuxText
#define BE baseError

int bCaly = 1
long trId, doCnt
string sMsgZb1, sMsgZb2
string sMsgBezPod = "Nastpujcy kontrahenci nie maj zdefiniowanego numeru rachunku bankowego:\n"
string sMsgTraUje = "Nastpujcy kontrahenci maj transakcje na kwoty ujemne:\n"
string sMsgEP
int iMsgBezPod = 0, iMsgTraUje = 0, iMsgBezKursu = 0, iMsgEPrz = 0

long kthCalyRach

// do prezentacji wyboru rachunku
record sheet
	string kol1[ 100 ]
	string kol2[ 100 ]
	long rid // id rachunku
endrec

BASEHANDLE bk, bp, bu, br, bks, bb, bz, bt, broz
bk = dbOpen( DN_KTH, true )
bp = dbOpen( DN_PRAC, true )
bu = dbOpen( DN_URZ, true )
#ifdef FORTE
br = dbOpen( "rachunkifirmy", true )
#else
br = dbOpenRok( "rachunki", indeksRoku(), true )
#endif
bks = dbOpenDokBase( indeksRoku(), ZRODLO_KSIEGI, true )
bb = dbOpenDokBase( indeksRoku(), ZRODLO_BUFOR, true )
bz = dbOpenZapBase( indeksRoku(), ZRODLO_BUFOR, true )
bt = dbOpen( "transakcje", true )
broz = dbOpen( "rozliczenia", true )

infoDok dok
int bufIdx

mapValue kth : kth.type( void )

string curKth
int drukZb = 0
int pomBez = 0
int osoPrz = 0 // osobny przelew dla kadego rozrachunku (#47661)

int total = 0
int totalEp = 0
float kwTotal = 0.0 // kwota dokumentu
float kwTotalEp = 0.0 // kwota e-Przeleww

long ridUsed // id rachunku uytego
kthrachData kd

int sub ustawDaneKontrahenta( long id, string typ, long a_rid )
	BTERRORTYPE err
	bool ok = true

	sheet tabList( 1 )
	int kolumny( 2 ) = 150, 400
	int rbCnt, rbIdx
	bool bSetForCaly = false
	ridUsed = a_rid

	select case ucase( typ )
	case "K"
		SK( bk, "pozycja" )
		SKS( bk, "pozycja", id )
		err = GR( bk, EQ )
		BE( bk, 4 )
		nazwaOdbiorcy = GF( bk, "nazwa" )
		kodOdbiorcy = GF( bk, "kod" )
		miejscOdbiorcy = GF( bk, "miejscowosc" )
		ulicaOdbiorcy = GF( bk, "ulica" )
		domOdbiorcy = GF( bk, "numerDomu" )
		lokalOdbiorcy = GF( bk, "numerMieszk" )

		if czyEPrzelew() then
			// dla pozyskania guida w C++
			typOdbiorcy = SUBJECTKIND_CONTRACTOR
			pozycjaOdbiorcy = id
		endif

		// FKF12071
		// JELI dokument wskazany w transakcji (dokumencie) lub
		// kontynuujemy rach kontrahenta (bCaly) a zosta ju uprzednio wybrany
		// TO uywamy go bezkrytycznie
		// W PRZECIWNYM WYPADKU, o ile jest tylko jeden rachunek
		// to bierzemy go bez pytania
		// a jeli nie jest jedyny to wybr z listy (aktywnych).
		shrink tabList, -1
		rbIdx = 0
		if a_rid || ( bCaly && ( a_rid = kthCalyRach ) ) then
			if ISFORTE then
				kd.initById( GF( bk, "id" ), true ) // true - wszystkie
			else
				kd.initByBase( bk )
			endif
			while kthrachGet( kd )
				if a_rid == kd.id then
					rbIdx += 1
					if rbIdx > 1 then grow tabList, 1
					tabList( rbIdx ).kol1 = kd.symbol
					tabList( rbIdx ).kol2 = kd.numer
					tabList( rbIdx ).rid = kd.id
				endif
			wend
		else
			if ISFORTE then
				kd.initById( GF( bk, "id" ), false ) // false - tylko aktualne
			else
				kd.initByBase( bk )
			endif
			if bCaly then
				bSetForCaly = true
			endif
			while kthrachGet( kd )
				rbIdx += 1
				if rbIdx > 1 then grow tabList, 1
				tabList( rbIdx ).kol1 = kd.symbol
				tabList( rbIdx ).kol2 = kd.numer
				tabList( rbIdx ).rid = kd.id
			wend
		endif
		rbCnt = rbIdx
        rbIdx = 1
        if 1 < rbCnt then
            form ( using "Konta kontrahenta K%d : %s",id, GF( bk, "nazwa" ) ), 430, 200
                reclist "/LKonto|/LNumer", tabList, rbIdx, 10, 10, 400, 130, kolumny, FORMRETVAL_IDOK
                button FORMTEXT_IDOK, 120, 140, 70, 30, FORMRETVAL_IDOK
                button FORMTEXT_IDCANCEL, 250, 140, 70, 30, FORMRETVAL_IDCANCEL
            err = execForm
            if err != FORMRETVAL_IDOK then error ""
        endif
		if bSetForCaly && rbCnt then
			kthCalyRach = tabList( rbIdx ).rid
		endif
		ridUsed = tabList( rbIdx ).rid
        arg4 = tabList( rbIdx ).kol1
        arg5 = tabList( rbIdx ).kol2
	case "P"
		SK( bp, "pozycja" )
		SKS( bp, "pozycja", id )
		err = GR( bp, EQ )
		BE( bp, 4 )
		nazwaOdbiorcy = using "%s %s", GF( bp, "imie1" ), GF( bp, "nazwisko" )
		kodOdbiorcy = GF( bp, "st_kod" )
		miejscOdbiorcy = GF( bp, "st_miejscowosc" )
		ulicaOdbiorcy = GF( bp, "st_ulica" )
		domOdbiorcy = GF( bp, "st_numerDomu" )
		lokalOdbiorcy = GF( bp, "st_numerMieszk" )
		arg4 = GF( bp, "rch_symbol" )
		arg5 = GF( bp, "rch_numer" )
		if len( arg5 ) >= 29 then arg5 += GAT( 0, BFI_PRACOWNICY, id, 1 )
		if czyEPrzelew() then
			// dla pozyskania guida w C++
			typOdbiorcy = SUBJECTKIND_EMPLOYEE
			pozycjaOdbiorcy = id
		endif
	case "U"
		SK( bu, "pozycja")
		SKS( bu, "pozycja", id )
		GR( bu, EQ )
		BE( bu, 4 )
		nazwaOdbiorcy = GF( bu, "nazwa" )
		kodOdbiorcy = GF( bu, "kod" )
		miejscOdbiorcy = GF( bu, "miejsce" )
		ulicaOdbiorcy = GF( bu, "ulica" )
		domOdbiorcy = GF( bu, "nrDomu" )
		lokalOdbiorcy = ""
		arg4 = GF( bu, "symbol" )
		arg5 = GF( bu, "rachunek" )
		if len( arg5 ) >= 29 then arg5 += GAT( 0, BFI_URZEDY, id, 1 )
	case else
		ok = false
		arg4 = ""
		arg5 = ""
	endselect

	if ok then
		// FMT_DANEFIRMY (strdat.h)
		arg3 = using "%s\n%s %s\n%s %s/%s", nazwaOdbiorcy, kodOdbiorcy, miejscOdbiorcy, ulicaOdbiorcy, domOdbiorcy, lokalOdbiorcy
	else
		arg3 = nazwaOdbiorcy = kodOdbiorcy = miejscOdbiorcy = ulicaOdbiorcy = domOdbiorcy = lokalOdbiorcy = ""
	endif
endsub

long idRoz = 0
int poz = 0
string strKonto
string curData = data()
string dataokr = data( okres( curdata ) )
if dateutilOkresZDaty( curdata ) == dateutilOkresZDaty( dataokr ) then
	dataokr = curdata //zgodny rok i miesic - podstawiamy take dzien
endif

float kwWO
float kursWO

void sub dodajZapisIRozl( long epi, float kwotaZap, string opis )
	long traId

	if bufIdx < 2 then exit
	dok.insert( 1 )
    dok.SF( 1, "kwota", kwotaZap )
	dok.SF( 1, "strona", 0 )
	dok.SF( 1, "pozycja", poz )
	dok.SF( 1, "rozbicie", 0 )
	dok.SF( 1, "idDlaRozliczen", idRoz += 1 )
	dok.SF( 1, "nrRozbKP", 3 )
    dok.SF( 1, "opis", ( using "Za: %s", opis ) )
	dok.SF( 1, "typOpisu", 1 )
	dok.SF( 1, "synt", GF( bt, "synt" ) )
	dok.SF( 1, "poz1", GF( bt, "poz1" ) )
	dok.SF( 1, "poz2", GF( bt, "poz2" ) )
	dok.SF( 1, "poz3", GF( bt, "poz3" ) )
	dok.SF( 1, "poz4", GF( bt, "poz4" ) )
	dok.SF( 1, "poz5", GF( bt, "poz5" ) )
	dok.SF( 1, "dataokr", dataOkr )

	dok.insert( 4 )
	dok.SF( 4, "transakcja", GF( bt, "id" ) )
	dok.SF( 4, "strona", 0 )
	dok.SF( 4, "kwota", kwotaZap )
	dok.SF( 4, "idDlaRozliczen", idRoz )
	dok.SF( 4, "synt", GF( bt, "synt" ) )
	dok.SF( 4, "poz1", GF( bt, "poz1" ) )
	dok.SF( 4, "poz2", GF( bt, "poz2" ) )
	dok.SF( 4, "poz3", GF( bt, "poz3" ) )
	dok.SF( 4, "poz4", GF( bt, "poz4" ) )
	dok.SF( 4, "poz5", GF( bt, "poz5" ) )

	if GF( bt, "waluta" ) then
		// pola dla waluty obcej
		dok.SF( 4, "walutaObca", GetField( bt, "waluta" ) )
		dok.SF( 4, "wkwota", kwWO )
		dok.SF( 4, "rozliczonoWO", kwWO )
		dok.SF( 4, "kursWO", kursWO )
	else
		dok.SF( 4, "walutaObca", "" )
	endif

	if czyEPrzelew() then
		log( "Zapamituj dla waciwego powizania z e-Przelewem.\n" )
		idxRozl += 1
//		epCntRozl( epi ) += 1
		log( using "\tidxRozl += 1 [ now %d ]\n", idxRozl )
		log( using "\tepCntRozl( %d ) += 1 [ now %d ]\n", epi, epCntRozl( epi ) )
	endif

	dok.insert( 1 )
    dok.SF( 1, "kwota", kwotaZap )
	dok.SF( 1, "strona", 1 )
	dok.SF( 1, "pozycja", poz )
	dok.SF( 1, "rozbicie", 1 )
	dok.SF( 1, "idDlaRozliczen", idRoz += 1 )
	dok.SF( 1, "nrRozbKP", 2 )
    dok.SF( 1, "opis", ( using "Za %s", opis ) )
	dok.SF( 1, "typOpisu", 2 )
	dok.SF( 1, "dataokr", dataOkr )
	buf = strKonto
	if find regular "{[0-9]^3}-" then dok.SF( 1, "synt", val( regular 1 ) )
	if find regular "/-{[0-9]##}-" then dok.SF( 1, "poz1", val( regular 1 ) )
	if find regular "/-{[0-9]##}-" then dok.SF( 1, "poz2", val( regular 1 ) )
	if find regular "/-{[0-9]##}-" then dok.SF( 1, "poz3", val( regular 1 ) )
	if find regular "/-{[0-9]##}-" then dok.SF( 1, "poz4", val( regular 1 ) )
	if find regular "/-{[0-9]##}-" then dok.SF( 1, "poz5", val( regular 1 ) )
	poz += 1
endsub

// kontrahenci bez nazwy ju znalezieni
mapValue mvKthBez : mvKthBez.type( int )

// kontrahenci z transakcjami na ujemne kwoty
mapValue mvTraUje : mvTraUje.type( int )

string sub buildKthKey()
	buildKthKey = using "%s %s %s", rozlistGetVal( ROZLIST_COL_KONTRSYMB ), rozlistGetVal( ROZLIST_COL_KONTRNR ), rozlistGetVal( ROZLIST_COL_KONTR )
endsub

bool bWspolnyKurs // czy tryb wsplnego kursu waluty (wybr w oknie parametrw)
float wspolnyKurs // wsplny kurs

dispatch xKZ // obiekt sucy podaniu kursw dla poszczeglnych zobowiza walutowych (#64225)

float sub getKursWalutyZoknaZbiorczego( long idTra )
	if bWspolnyKurs then
		getKursWalutyZoknaZbiorczego = wspolnyKurs
	else
		xKZ.biezaceId = idTra
		xKZ.getKursZb()
		getKursWalutyZoknaZbiorczego = xKZ.kursZb
	endif
endsub

// 0.0 jeli niewybrano
float sub getKursWalutyZlinku( string sWal )
	getKursWalutyZlinku = linkKurs( sWal )
endsub

string sWal // wybrana waluta dla e-Przeleww (robimy tylko dla jednej waluty)

// ograniczenie do jednej waluty obowizuje tylko dla e-Przeleww
bool sub czyWalutaZgodna()
	czyWalutaZgodna = !czyEPrzelew() || sWal == rozlistGetVal( ROZLIST_COL_WALUTA )
endsub

// Procesowanie wszystkich rozrachunkw kolejnego napotkanego kontrahenta
void sub wykonaj( long idxOd )
	long traId
	long rid
	string nxdok
	float nxkw
	bool bFound = false
	string sTytulem = ""
	long epi = 0 // index na liscie ep
	bool bNewEp
	bool bIsRoom
	bool bDoProcess

	float kursWaluty
	float kwPrz = 0.0 // kwota przelewu moe si skadac z kilku rozlicze, jeli nie osobno 
	kthCalyRach = 0

    long kid // id kartoteki
    string ktyp

	// w celu oszczdzania miejsca w Tytuem, nie powtarzamy numerw dokumentw
	mapValue mvNxDok
	mvNxDok.type( void )

	long ii = idxOd - 1 // za chwil zwikszymy
    kid = val( rozlistGetVal( ROZLIST_COL_KONTRNR ) )
    ktyp = rozlistGetVal( ROZLIST_COL_KONTRSYMB )
    rid = val( rozlistGetVal( ROZLIST_COL_RACHID ) )
	ustawDaneKontrahenta( kid, ktyp, rid )
	while ( ii += 1 ) <= doCnt // nawias kunieczny
		rozlistDaneOkna( ii )
		if czyWalutaZgodna() then
			select case rozlistGetVal( ROZLIST_COL_STAN )
			case "Z B", "Z P", "Z T"
				if curKth == buildKthKey() then
					//to jest rozrachunek biecego kontrahenta
					if !arg5 then
						// nie ma rachunku
						if !mvKthBez.index( curKth ) then
							select case mvKthBez.size() // raportujemy
							case Is < 10
								sMsgBezPod += using "- %s\n", curKth
							case 10
								sMsgBezPod += "...\n"
							endselect
							mvKthBez.set( curKth, 0 )
						endif
						iMsgBezPod += 1
	
						if pomBez then // pomijamy bez rachunku
							bFound = false
							exit // z while
						endif
					endif
	
					SK( bt, "id" )
					SKS( bt, "id", traId = val( rozlistGetVal( ROZLIST_COL_TRANS ) ) )
					GR( bt, EQ )
					BE( bt, 4 )
	
					if GF( bt, "waluta" ) then
				    	nxkw = valFmt( rozlistGetVal( ROZLIST_COL_KWOTAW ) )
					else
				    	nxkw = valFmt( rozlistGetVal( ROZLIST_COL_KWOTA ) )
					endif
	
					if nxkw < 0.0 then
						//bug #9343
						if !mvTraUje.index( curKth ) then
							select case mvTraUje.size() // raportujemy
							case Is < 10
								sMsgTraUje += using "- %s\n", curKth
							case 10
								sMsgTraUje += "...\n"
							endselect
							mvTraUje.set( curKth, 0 )
						endif
						iMsgTraUje += 1
						bFound = false
						exit // z while
					endif
	
					bDoProcess = true
					if GF( bt, "waluta" ) then
						if czyEPrzelew() then
							kursWaluty = getKursWalutyZoknaZbiorczego( GF( bt, "id" ) )
						else
							kursWaluty = getKursWalutyZlinku( GF( bt, "waluta" ) )
						endif
						if kursWaluty then
							kwWO = nxkw
							kursWO = kursWaluty
							nxkw *= kursWaluty
						else
							iMsgBezKursu += 1
							bDoProcess = false
						endif
					endif
	
					if bDoProcess then
						// Zapamitanie dotychczasowego "tytuem",
						// bo po dodaniu kolejnego rozrachunku moze by za dugi
						// lub te w kryteriach wybrano opcj eby osobno
			           	arg7 = sTytulem
		
						buf = rozlistGetVal( ROZLIST_COL_DOKUMENT )
						if find regular "^{*}.{([~.])##}$" then //bug 3254
							nxdok = regular 2
						else
							nxdok = buf
						endif
						nxdok = stringNormalize( nxdok, 0 ) // oszczdzamy miejsce - adnych spacji
	
						if !mvNxDok.index( nxdok ) then
							if mvNxDok.size() then
								sTytulem += "," // oszczdzamy miejsce - adnych spacji
							endif
							sTytulem += nxdok
							mvNxDok.set( nxdok, VOIDVAL )
						endif
	
						bIsRoom = isRoom( sTytulem )
						bFound = true
	
						if czyEPrzelew() then
							// czy kolejny ePrzelew ma by dodany ?
							bNewEp = false
							if !bFound then
								bNewEp = true // pierwszy dla podmiotu
							else
								if !epi then
									bNewEp = true // pierwszy w ogle
								else
									if osoPrz then
										if epCntRozl( epi ) then
											bNewEp = true // kolejny
										endif
									else
										if !bIsRoom then
											bNewEp = true // nie mieci si, dodajemy w tym wypadku przed wystawieniem poprzedniego
										endif
									endif
								endif
							endif
									
							if bNewEp then
								log( "Przygotowanie do kolejnego e-Przelewu.\n" )
								epi = size( ep )
								ep( epi ).init( false, DO_PODM )
								ep( epi ).wyczysc()
								epIdxRozl( epi ) = idxRozl
								epCntRozl( epi ) = 0
								log( using "\tepIdxRozl( %d ) = %d\n", epi, idxRozl )
								log( using "\tepCntRozl( %d ) = 0\n", epi )
		
								epOK( epi ) = true
								grow ep, 1
								grow epIdxRozl, 1
								grow epCntRozl, 1
								grow epOK, 1
							endif
		
							//if bufIdx < 2 then
								log( "Dodajemy do listy id rozliczanych transakcji.\n" )
								ep( epi ).dodajTrans( traId )
								epCntRozl( epi ) += 1
								log( using "\tep( %d ).DodajTrans( %l )\n", epi, traId )
								log( using "\tepCntRozl( %d ) += 1 [ now %d ]\n", epi, epCntRozl( epi ) )
							//endif
						endif
		
						if czyEPrzelew() && osoPrz then
							// osobno obsuguj bo inaczej rozjazd przy powizywaniu
							total += 1
							kwTotal += nxKw
							if dodajEPrzelew( epi, arg3, arg5, nxKw, arg0, arg2, nxDok, arg8 ) then
								totalEp += 1
								kwTotalEp += nxKw
							else
								iMsgEPrz += 1
							endif
						else
							if kwPrz then
								if osoPrz || !bIsRoom then
									//wystawiamy przelew/e-Przelew
									sTytulem = arg7
				
									total += 1
									kwTotal += kwPrz
		
									if czyEPrzelew() then
										// zabieg poniej poniewa dodany zosta awansem kolejny e-Przelew ju wczeniej
										if dodajEPrzelew( epi - !bIsRoom, arg3, arg5, kwPrz, arg0, arg2, sTytulem, arg8 ) then
											totalEp += 1
											kwTotalEp += kwPrz
										else
											iMsgEPrz += 1
										endif
									else
										dodajPrzelew( arg3, arg5, kwPrz, arg0, arg2, sTytulem, arg8 )
									endif
		
									kwPrz = 0.0
				                    sTytulem = nxDok
	
									// budujemy tytuem dla kolenego przelewu
									mvNxDok.clear()
									mvNxDok.set( nxdok, VOIDVAL ) // to jedyny na razie
				                endif
							endif
							kwPrz += nxKw
						endif
		
						dodajZapisIRozl( epi, nxKw, nxDok )
					endif
				endif
			endselect
		endif
	wend

	if bFound && kwPrz then
		// pozostao cos do wystawienia z uwagi na grupowanie
		total += 1
		kwTotal += kwPrz
		if czyEPrzelew() then
			// tu tylko gdy !osoPrz powinien wej z uwagi na osobn obsug osoPrz w gwnej ptli
			if dodajEPrzelew( epi, arg3, arg5, kwPrz, arg0, arg2, sTytulem, arg8 ) then
				totalEp += 1
				kwTotalEp += kwPrz
			else
				iMsgEPrz += 1
			endif
		else
			dodajPrzelew( arg3, arg5, kwPrz, arg0, arg2, sTytulem, arg8 )
		endif
	endif
endsub

//pobieramy kolejno dane kontrahentw
// wpierw aduj wszystkie dane okna, zapamituj ich ilo ...
// bez tego nie zadziaa ...
doCnt = 0
long id = rozlistGetId( FS )
while id
	doCnt += 1
	id = rozlistGetId( NX )
wend

#define S_EPZ_TITLE "e-Przelew zbiorczy"

mapValue mvWal

void sub wybierzWalute()
	string asWal( mvWal.size() )
	int idx = 1
	while idx <= size( asWal )
		asWal( idx ) = mvWal.getKey( idx )
		idx += 1
	wend
	FORMRETVALTYPE rv
	form S_EPZ_TITLE, 380, 150
	text "Wybrano rozrachunki w wicej ni jednej walucie.", 15, 10, 340, 25
	text "e-Przelew zbiorczy moe by wykonany tylko dla jednej waluty.", 15, 35, 340, 25
	text "Prosz wybra walut dla e-Przelewu zbiorczego:", 15, 60, 250, 25
	cmbbox "", asWal, sWal, 270, 58, 70, 100
    button "&Wybierz", 80, 95, 70, 24, FORMRETVAL_IDOK
    button FORMTEXT_IDCANCEL, 220, 95, 70, 24, FORMRETVAL_IDCANCEL
	rv = execform
	if FORMRETVAL_IDOK != rv then error ""
endsub

long idx
if czyEPrzelew() then
	mvWal.type( void )
	idx = 0
	while ( idx += 1 ) <= doCnt // nawias kunieczny
		rozlistDaneOkna( idx )
		mvWal.set( rozlistGetVal( ROZLIST_COL_WALUTA ), VOIDVAL )
	wend
	if 1 < mvWal.size() then
		mvWal.sort()
		wybierzWalute()
	else
		if 1 == mvWal.size() then
			sWal = mvWal.getKey( 1 )
		endif
	endif
endif

int cPomBez

int sub paramsOnCommand( int id, int msg )
	if !id && !msg then
		if czyEPrzelew() then
			// blokada, ze wzgldu na EDS
			enable( cPomBez, 0 )
		endif
	endif
endsub

string defDok( 1 ) = "== Nie wprowadzaj =="
int dokLen = 1

dispatch fi = application.wybranaFirma

int prawoRoz = fi.prawoOperacji( "ROZ_WPR" )
recmsg rmsg
FORMCTRLIIDTYPE idBreak
if !prawoRoz then
	rmsg.setText( "Nie masz nadanych praw do obsugi rozrachunkw.\nCzy chcesz kontynuowa bez wprowadzenia dokumentu do bufora?", MSG_ICONQUEST )
	rmsg.addYes( 0 )
	idBreak = rmsg.addNo( MSG_BUTMODE_DEF )
	rmsg.showAndExitIf( idBreak )
endif

BASEHANDLE fdDok
BTERRORTYPE err
int bPrawo = fi.prawoOperacji( "INN_PLW" ) && fi.prawoOperacji( "DOK_WPR" )
if bPrawo then
	fdDok = dbOpenRok( "def_dok", indeksRoku(), true )
	SK( fdDok, "id" )
	err = GR( fdDok, FS )
	while !err
		if ( GF( fdDok, "dWzor" ) == DW_PROSTY || GF( fdDok, "dWzor" ) == DW_WYCIAG_B ) && fi.operacjaTypDok( GF( fdDok, "dSkrot" ) ) then
			grow defDok, 1
			defDok( dokLen += 1 ) = using "%-4.4s %s", GF( fdDok, "dSkrot" ), GF( fdDok, "dNazwa" )
		endif
		err = GR( fdDok, NX )
	wend
	dbClose( fdDok )
endif

#define INISEC "Przelew"
#define IE_SYMB "symbol"
#define IE_NR "numer"
#define IE_ID "id"
#define IE_KNT "konto"
#define IE_WPR "wprowadz"
#define IE_ZB "zbiorowka"
#define IE_PB "pombez"
#define IE_OP "osoPrz"
string IFN = plikFK()

nazwaNadawcy = firma.nazwa
ulicaNadawcy = firma.ulicaTylko
domNadawcy = firma.dom
lokalNadawcy = firma.lokal
miejscNadawcy = firma.miastoTylko
kodNadawcy = firma.kod
// FMT_DANEFIRMY (strdat.h)
arg0 = using "%s\n%s %s\n%s %s/%s", nazwaNadawcy, kodNadawcy, miejscNadawcy, ulicaNadawcy, domNadawcy, lokalNadawcy
arg1 = getIni( INISEC, IE_SYMB, IFN )
arg2 = getIni( INISEC, IE_NR, IFN )
long rbID = val( getIni( INISEC, IE_ID, IFN ) )
strKonto = getIni( INISEC, IE_KNT, IFN )
bufIdx = val( getIni( INISEC, IE_WPR, IFN ) )
if !bufIdx || !bPrawo then bufIdx = 1
drukZb = val( getIni( INISEC, IE_ZB, IFN ) )
if !czyEPrzelew() then
	pomBez = val( getIni( INISEC, IE_PB, IFN ) )
else
	pomBez = 1 // zapis do EDS bez rachunkw i tak si nie uda (walidacja odrzuca)
endif
osoPrz = val( getIni( INISEC, IE_OP, IFN ) )
arg8 = data() //data przelewu

FORMRETVALTYPE rv
int przelzbDY
string sKurs

#define KURS_HEI 30

int dlgHei = 350
if sWal && "z" != sWal then
	dlgHei += KURS_HEI
endif

#define FORMRETVAL_IDLINKRACH 3
#define FORMRETVAL_IDLINKKURS 4
#define FORMRETVAL_WIELEKURSOW 5

string sKurs0 = sKurs = kwota( 0.0, 8 )

RETRY:

if czyEPrzelew() then
	form S_EPZ_TITLE, 350, dlgHei
else
	form "Zbiorcze polecenia przelewu", 350, dlgHei
endif
	text "Nasze konto bankowe:", 15, 10, 160, 24
	button "&Kartoteka", 180, 7, 70, 24, FORMRETVAL_IDLINKRACH
	edit "W banku", arg1, 80, 35,  240, 24
	edit "Nr rachunku", arg2, 80, 60,  240, 24
	edit "Konto", strKonto, 90, 90, 180, 24
	datedit "Data przelewu", arg8, 90, 120, 90, 24
	cmbBox "Do bufora", defDok, bufIdx, 90, 150, 180, 100
    if bNowy then // bNowy zadeklaruj tam gdzie includujesz
        chkBox "Kontynuuj numer rachunku odbiorcy", bCaly, 15, 175, 210, 24
    endif
	cPomBez = chkBox "Pomijaj kontrahentw bez numeru rachunku", pomBez, 15, przelzbDY = 200, 250, 24
    chkBox "Osobny przelew do kadego rozrachunku", osoPrz, 15, przelzbDY += 25, 250, 24
    chkBox "Drukuj zbiorwk", drukZb, 15, przelzbDY += 25, 180, 24
if sWal && "z" != sWal then
	edit "Kurs " + sWal + ":", sKurs, 90, przelzbDY += KURS_HEI, 70, 24
	button "...", 160, przelzbDY, 25, 24, FORMRETVAL_IDLINKKURS
	button "Uyj wielu kursw...", 195, przelzbDY, 125, 24, FORMRETVAL_WIELEKURSOW
endif
    button "&Wykonaj", 90, przelzbDY += 35, 70, 24, FORMRETVAL_IDOK
    button FORMTEXT_IDCANCEL, 195, przelzbDY, 70, 24, FORMRETVAL_IDCANCEL
rv = execform paramsOnCommand

select case rv
case FORMRETVAL_IDLINKRACH
	rbId = Link( FKUTIL_LINKID_RACH, rbId )
	if rbID > 0 then
		SK( br, "id" )
		SKS( br, "id", rbId )
		GR( br, EQ )
		arg1 = GF( br, "symbol" )
		arg2 = GF( br, "numer" )
		if len( arg2 ) >= 29 then arg2 += GAT( 0, BFI_RACHUNKI, rbId, 1 )
	endif
	goto RETRY
case FORMRETVAL_IDLINKKURS
	sKurs = using "%.8f", linkKurs( sWal )
	goto RETRY
case FORMRETVAL_IDOK
	if sWal && "z" != sWal && sKurs0 == sKurs then
		message "Prosz wybra kurs waluty."
		goto RETRY
	endif
	wspolnyKurs = val( sKurs ) 
	bWspolnyKurs = true
case FORMRETVAL_WIELEKURSOW
	bWspolnyKurs = false
	xKZ = xFactory.newObject( "BKursyZbiorcze" )
	if !xKZ then error "BKursyZbiorcze"
	xKZ.listarozr = XROWSDATA
	if xKZ.listarozr then
		xKZ.typWyboru = val( arg7 )
		xKZ.biezaceid = XROWSPARAM.biezaceid
		xKZ.waluta = sWal
		xKZ.load
	endif
	hideBasForm()
	xKZ.oknoModalne
	showBasForm()
	if 1 != xKZ.uiResult then // 1 = IDOK w C++, czyli wybrano "Zle"
		error ""
	endif
	rv = FORMRETVAL_IDOK
endselect

if rv != FORMRETVAL_IDOK then error ""

if arg8 then curData = arg8

putIni( INISEC, IE_SYMB, arg1, IFN )
putIni( INISEC, IE_NR, arg2, IFN )
putIni( INISEC, IE_ID, ( using "%l", rbId ), IFN )
putIni( INISEC, IE_KNT, strKonto, IFN )
putIni( INISEC, IE_WPR, ( using "%d", bufIdx ), IFN )
putIni( INISEC, IE_ZB, ( using "%d", drukZb ), IFN )
if !czyEPrzelew() then
	putIni( INISEC, IE_PB, ( using "%d", pomBez ), IFN )
endif
putIni( INISEC, IE_OP, ( using "%d", osoPrz ), IFN )

dok.bDok = bb
dok.bZap = bz
dok.bKsie = bks
dok.begin( 1 )

idx = 0
while ( idx += 1 ) <= doCnt // nawias kunieczny
	rozlistDaneOkna( idx )
	popup( 2, idx )
	if !kth.index( curKth = buildKthKey() ) && czyWalutaZgodna() then
		popup( 1, curKth )
		kth.set( curKth, VOIDVAL )
		wykonaj( idx )
	endif
wend

long nrEw
float kwTr

if iMsgBezPod then
	if pomBez then
		if czyEPrzelew() then
			sMsgBezPod += "e-Przelewy dla tych kontrahentw nie zostan wystawione."
		else
			sMsgBezPod += "Przelewy dla tych kontrahentw nie zostan wystawione."
		endif
	else
		if czyEPrzelew() then
			sMsgBezPod += "e-Przelewy dla tych kontrahentw zostan wystawione z niewypenionym numerem rachunku odbiorcy."
		else
			sMsgBezPod += "Przelewy dla tych kontrahentw zostan wystawione z niewypenionym numerem rachunku odbiorcy."
		endif
	endif
	message sMsgBezPod
endif

if iMsgTraUje then
	sMsgTraUje += "Transakcje na kwoty ujemne zostan pominite."
	message sMsgTraUje
endif

if iMsgBezKursu then
	message "Pominito transakcje walutowe, dla ktrych nie wskazano kursu waluty."
endif

#ifdef FORTE
dispatch cn
#endif

// zapisuje dokument
void sub writeDocument()
	buf = defDok( bufIdx )
	find regular "^{*} " //cig znakw i spacja
	buf = regular 1
	dok.SF( 0, "kwota",  kwTotal )
	dok.SF( 0, "kwotaZRow",  kwTotal )
	dok.SF( 0, "sygnatura", firma.sygnatura )

	nrEw = numerEwid( buf, bb, bks, dataOkr ) // zapisze dataokr i okres do DATA bb ...
	// ... pola jak wyej naley przepisa do DATA infoDok, bo inaczej si nie zapisz do bazy
	dok.SF( 0, "dataOkr", getField( bb, "dataOkr" ) )
	dok.SF( 0, "okres", getField( bb, "okres" ) )

	dok.SF( 0, "skrot", buf )
	dok.SF( 0, "numer", nrEw )
	dok.SF( 0, "nazwa", ( using "Przelew %s", dok.nrEwToStr() ) )

	if czyEPrzelew() then
		dok.SF( 0, "tresc", "Zbiorczy e-Przelew z dn. " + curData )
	else
		dok.SF( 0, "tresc", "Zbiorcze polecenie przelewu z dn. " + curData )
	endif
	dok.SF( 0, "datadok", curData )
	dok.SF( 0, "datawpr", curData )
	dok.SF( 0, "dataoper", curData )

	log( "dok.InsRec()\n" )
	err = dok.insRec()

#ifdef FORTE
	string qry = using "EXEC fk_TransakcjePotencjalneDokumentu %l, %d", dok.GF( 0, "id" ), indeksRoku()
	if !cn then cn = getAdoConnection()
	cn.execute( qry )
#endif

    dok.sprawdzDokument()
endsub

long epidx

#define S_KEINE_EP "Nie zlecono e-Przeleww."

if 0 == total + iMsgBezPod + iMsgTraUje + iMsgBezKursu + iMsgEPrz then
	message "Brak wybranych nierozliczonych zobowiza."
	error ""
else
	if total then
		if bufIdx > 1 then
			// Zapis dokumentu i rozlicze.
			// Dopiero po tym mona zapisa powizania.
			writeDocument()

			if err then
				sMsgZb1 = "Bd zapisywania dokumentu do bufora,\ndokument nie zosta wprowadzony."
				if czyEPrzelew() then
					if totalEp then
						sMsgZb2 = using "Liczba zleconych e-Przeleww: %d\nNa ogln kwot: %s z.", totalEp, kwota( kwTotalEp )
					else
						sMsgZb2 = S_KEINE_EP
					endif
				else
					sMsgZb2 = using "Liczba wystawionych przeleww: %d\nNa ogln kwot: %s z.", total, kwota( kwTotal )
				endif
			else
				if czyEPrzelew() then
					if totalEp then
						sMsgZb1 = using "Liczba zleconych e-Przeleww: %d\nNa ogln kwot: %s z.\nDo bufora wprowadzono %s.\nUWAGA: Stan rozrachunkw zosta zmodyfikowany,\nnaley ponownie stworzy list rozrachunkw.", totalEp, kwota( kwTotalEp ), nrEwToStr( buf, nrEw, dataOkr )
					else
						sMsgZb1 = using "%s\nDo bufora wprowadzono %s.\nUWAGA: Stan rozrachunkw zosta zmodyfikowany,\nnaley ponownie stworzy list rozrachunkw.", S_KEINE_EP, nrEwToStr( buf, nrEw, dataOkr )
					endif
				else
					sMsgZb1 = using "Liczba wystawionych przeleww: %d\nNa ogln kwot: %s z\nDo bufora wprowadzono %s.\nUWAGA: Stan rozrachunkw zosta zmodyfikowany,\nnaley ponownie stworzy list rozrachunkw.", total, kwota( kwTotal ), nrEwToStr( buf, nrEw, dataOkr )
				endif
			endif
		else
			if czyEPrzelew() then
				if totalEp then
					sMsgZb1 = using "Liczba zleconych e-Przeleww: %d\nNa ogln kwot: %s z.", totalEp, kwota( kwTotalEp )
				else
					sMsgZb1 = S_KEINE_EP
				endif
			else
				sMsgZb1 = using "Liczba wystawionych przeleww: %d\nNa ogln kwot: %s z.", total, kwota( kwTotal )
			endif
		endif
		
		if czyEPrzelew() then
			// dokument ju zapisany i rozliczenia te, mona zapisa powizania
			epidx = 1
			while epidx < size( ep )
				if epOK( epidx ) then
					if ep( epidx ).dodajRelacje( dok.getField( 0, "id" ), epIdxRozl( epidx ), epCntRozl( epidx ) ) then
						log( "Zapisywanie powiza.\n" )
						log( using "\tep( %d ).dodajRelacje( %l, %d, %d )\n", epidx, dok.getField( 0, "id" ), epIdxRozl( epidx ), epCntRozl( epidx ) )
					else
						sMsgEP = "Bd wystawiania e-Przelewu.\nBd EDS podczas zapisywania powiza e-Przelewu."
						if ep( epidx ).opisBledu() then
							sMsgEP += "\n\n" + ep( epidx ).opisBledu()
						endif
						message sMsgEP
					endif
				endif
				epidx += 1
			wend
		endif
	else
		if czyEPrzelew() then
			message S_KEINE_EP
		else
			message "Nie wystawiono przeleww."
		endif
		error ""
	endif
endif
